#ifndef __CCOMCategoriesComboBox_h__
#define __CCOMCategoriesComboBox_h__

//
// CCOMCategoriesComboBox
//
// A ComboBox listing all COM objects from specified COM Category
//
// Written by Laurent Kemp (lkempe@netcourrier.com) for Tech Head WebSite
// Copyright (c) 2001 Laurent Kemp.
//
// It subclasses a ComboBox control.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage to you or your
// computer whatsoever. It's free, so don't hassle me about it.
//

#pragma once

#include <ComCat.h>

#ifndef __ATLWIN_H__
  #error piechart.h requires atlwin.h to be included first
#endif

#ifndef __ATLCTRLS_H__
  #error CCOMCategoriesComboBox.h requires atlctrls.h to be included first
#endif

#ifndef __ATLCRACK_H__
  #error CCOMCategoriesComboBox.h requires atlcrack.h to be included first
#endif

#ifndef __ATLMISC_H__
  #error CCOMCategoriesComboBox.h requires atlmisc.h to be included first
#endif

#ifndef __ATLCTRLX_H__
  #error CCOMCategoriesComboBox.h requires atlctrlx.h to be included first
#endif

class CCOMCategoriesComboBox : 
	public CWindowImpl<CCOMCategoriesComboBox, CComboBox, CControlWinTraits>
{

public:

	DECLARE_WND_SUPERCLASS(_T("CCOMCategoriesComboBox"), CComboBox::GetWndClassName())	

	CCOMCategoriesComboBox( const CATID & catid, 
							CString strRegKeyHive = "", 
							CString strRegKeyValueName = "" );

	CCOMCategoriesComboBox( LPCTSTR psCatid, 
							CString srrRegKeyHive = "", 
							CString strRegKeyValueName = "" );

	virtual ~CCOMCategoriesComboBox();

	//////////////////////////////////////////////////////////////////////////

	typedef CWindowImpl<CCOMCategoriesComboBox, CComboBox, CControlWinTraits> 
		thisClass;

	BEGIN_MSG_MAP_EX(thisClass)

		MSG_WM_DESTROY( OnDestroy )

		REFLECTED_COMMAND_CODE_HANDLER_EX( CBN_SELCHANGE, OnSelChange )
		REFLECTED_COMMAND_CODE_HANDLER_EX( CBN_DROPDOWN, OnDropDown )

		DEFAULT_REFLECTION_HANDLER()

	END_MSG_MAP()

	//////////////////////////////////////////////////////////////////////////

	void OnDestroy();
	void OnSelChange( UINT msg, int id, HWND hwnd );
	void OnDropDown( UINT msg, int id, HWND hwnd );

	//////////////////////////////////////////////////////////////////////////

	BOOL SubclassWindow(HWND hWnd);
	void Destroy();

	//////////////////////////////////////////////////////////////////////////
	
protected:

	void Init();

	//////////////////////////////////////////////////////////////////////////
	
protected:

	CATID		m_catid;
	CString		m_strRegKeyHive;
	CString		m_strRegKeyValueName;
	CString		m_strRegKeyValueIID;
	bool		m_bReadAll;

	void	BuildList();
	void	ReadFromRegistry();
	void	WriteToRegistry();
};

#endif //__CCOMCategoriesComboBox_h__
